<div align="center">
  <img src="https://github.com/JamesMinoucha/Dispy/blob/main/assets/logo_horizon.png" width="250">
  </br></br>
  With the power of asynchronous and without its complexity.
  </br>
  <strong>Discord Bot Library</strong>
  </br></br>
  
  [![License: GPLv3](https://img.shields.io/badge/license-GPLv3-blue)](https://www.gnu.org/licenses/gpl-3.0.fr.html)
  ![Download Count](https://img.shields.io/github/downloads/JamesMinoucha/Dispy/total.svg)
  ![Made with Heart](https://img.shields.io/badge/Made_with-%F0%9F%A4%8D-green)
  </br>
  ![Static Badge](https://img.shields.io/badge/Made_using-Python-yellow?logo=python&logoColor=white)
  ![GitHub forks](https://img.shields.io/github/forks/JamesMinoucha/Dispy?style=flat)
</div>

# <p align="center"></p>

**Dispy** is a Python library that simplifies Discord bot development by handling all the complexities of asynchronous programming and API interactions. Unlike discord.py and discord.js, Dispy allows users to write straightforward Python code without worrying about intents, event loops, or async functions. The library runs everything asynchronously in the background, ensuring high performance without requiring the developer to manage any of it.

Whether you're building audio bots, text-based bots, or AI-powered bots, Dispy supports it all with minimal setup. Advanced users still have access to tools for more complex tasks, but for most, Dispy’s streamlined approach makes Discord bot development as simple as coding in Tkinter.

- **Easy to Use**
- **Fast & Optimized**
- **Code in syncronous**
- **Powerful Rest API**
- **Resume Gateway Support**

Dispy lets bot developers focus on their ideas and the structure of their bots instead of getting lost in the complexities of learning a library. It simplifies the development process, making it easier to bring creative concepts to life without the usual hassle.

> [!NOTE]
> This presentation is a concept, the [roadmap](https://github.com/JamesMinoucha/Dispy/tree/main?tab=readme-ov-file#roadmap) shows our progress

### Built With
- [Python](https://www.python.org/)
- [Asyncio](https://docs.python.org/fr/3/library/asyncio.html)
- [AioHttp](https://docs.aiohttp.org/en/stable/)
- [Discord API](https://discord.com/developers/docs/intro#explore-the-apis)

## <div align="center">Roadmap</div>
**Current Stat:** Beta</br>
**Current Version:** 0.1.0</br>
**Current Stability:** Mostly Stable</br>

- [x] Gateway
  - [ ] Resume Support
- [x] Event Handling @
- [x] Intents Calculator @
- [x] Rest API Support **
  - [x] Commun Function @
  - [x] Custom Function @
  - [ ] Rate Limiter
- [ ] Audio/Voice Support
- [ ] Support for images
- [ ] Application Command
  - [ ] Interpreter
- [x] Simpler Embed *
- [x] Autocompletion
  - [x] Gateway Event
  - [x] HTTP Request Return
  - [ ] HTTP Request Arguments
- [x] Exception Handling
- [ ] Sharding Support
- [ ] Support for server
  - [ ] Automatic Reconnection
  - [ ] Exception ignore
- [ ] RPC
- [ ] Timestamp Functions
- [x] Documentation
  - [ ] Getting Started *
  - [ ] Tutorials
  - [x] Changelogs
- [x] Internal Asynchronous Support
  - [x] Function for User
  - [x] Full object and autocompletion
- [ ] Log system

* \* Work in progress
* \*\* Not full support
* ~ Use it at your own risk
* @ Contribute to finish it!

## <div align="center">Contributing</div>
We truly appreciate any contributions! If you have suggestions for improvement, here’s how you can contribute:

1. **Fork the repository.**
2. **Create your Feature Branch (**`git checkout -b feature/CoolFeature`**)**
3. **Commit your Changes (**`git commit -m "Add some CoolFeature"`**)**
4. **Push to the Branch (**`git push origin feature/CoolFeature`**)**
5. **Open a pull request.**

If you'd like to suggest an improvement without coding, feel free to open an issue and tag it with "enhancement". And don’t forget to star the project if you find it helpful!

Thanks again for your contribution!

## <div align="center">License</div>

#### © 2024 JamesFrench

This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see https://www.gnu.org/licenses/

## <div align="center">Contact Us</div>

If you have any questions or suggestions, feel free to reach out to me:
- Email: **jamesfrench.contact@gmail.com**
- Discord: **Jamesfrench_**
